{ IRC (c) 2001 by Master-Soft
  Coded by TheMaster
  http://www.Master-Soft.de
}

unit IRC;

interface

Function LogonText(NickName, Ident,RealName:String):String; // Gibt den AnmeldeString fr den IRC Server zurck
Function IdentText(ReceiveText,OS,UserID:String):String; // Gibt den String des Ident Servers zurck
Function Ping(ReceiveText:String):Boolean; // berprft, ob eine Ping-Anfrage vorliegt
Function Pong(ReceiveText:String):String; // Gibt den zurckzugebenden Pong-Befehl zurck
Function GetAction(ReceiveText:String):String; // Gibt die IRC-Aktion/Nummer zurck
Function QuitIRC(Msg:String):String; // Gibt den Quit-String zurck
Function JoinChannel(Channel:String):String; // Gibt den Join-String zurck
Function PartChannel(Channel,Msg:String):String; // Gibt den part-String zurck
Function GetPerson(ReceiveText:String):String; // Gibt den Namen des Aktion-Auslsenden zurck
Function GetTarget(ReceiveText:String):String; // Gibt das Ziel (Channel/Nick) der Aktion zurck
Function PrivMsg(Target, Msg:String):String; // Gibt den String fr eine Private Nachticht an Channel/User zurck
Function GetMessage(ReceiveText:String):String; // Gibt die Nachricht zurck
Function GetFirstCom(ReceiveText:String):String; // Gibt das erste Command der Nachricht zurck
Function GetSecondCom(ReceiveText:String):String; // Gibt das zweite Command der Nachricht zurck
Function ServerCommand(Command:String):String; // Gibt den String fr ein direktes Serverkommando zurck
Function SetMode(Channel,Mode,Target:String):String; // Gibt den String fr das Setzten von Channel-Modes zurck
Function SetTopic(Channel,Topic:String):String; // Gibt den String fr das Setzten von Topics zurck

implementation

Function LogonText(NickName,Ident,RealName:String):String;
begin
  Result := 'NICK ' + NickName + #10 + 'USER ' + Ident + ' 0 0 :' + RealName + #10;
end;

Function IdentText(ReceiveText,OS,UserID:String):String;
begin
  Result := ReceiveText + ' : USERID : ' + OS + ' : ' + UserID + #10;
end;

Function Ping(ReceiveText:String):Boolean;
begin
  if Copy(ReceiveText, 1, 4) = 'PING' then Result := TRUE
  else Result := FALSE;
end;

Function Pong(ReceiveText:String):String;
begin
  Result := 'PONG ' + Copy(ReceiveText, 7, Length(ReceiveText)-6) + #10;
end;

Function GetAction(ReceiveText:String):String;
var i, i2 : Integer;
begin
  Result := '';
  if Length(ReceiveText) > 0 then
    if ReceiveText[1] = ':' then
      for i := 1 to Length(ReceiveText) do
        if ReceiveText[i] = ' ' then
          for i2 := i+1 to Length(ReceiveText) do
            if ReceiveText[i2] = ' ' then
            begin
              Result := Copy(ReceiveText, i+1, i2-i-1);
              Exit;
            end;
end;

Function QuitIRC(Msg:String):String;
begin
  Result := 'QUIT :' + Msg + #10;
end;

Function JoinChannel(Channel:String):String;
begin
  Result := 'JOIN ' + Channel + #10;
end;

Function PartChannel(Channel,Msg:String):String;
begin
  Result := 'PART ' + Channel + ' :' + Msg + #10;
end;

Function GetPerson(ReceiveText:String):String;
var i : Integer;
begin
  Result := '';
  if Length(ReceiveText) > 0 then
    if ReceiveText[1] = ':' then
      for i := 2 to Length(ReceiveText) do
        if ReceiveText[i] = '!' then
        begin
          Result := Copy(ReceiveText, 2, i-2);
          Exit;
        end;
end;

Function GetTarget(ReceiveText:String):String;
var i, i2, i3 : Integer;
begin
  Result := '';
  if Length(ReceiveText) > 0 then
    if ReceiveText[1] = ':' then
      for i := 1 to Length(ReceiveText) do
        if ReceiveText[i] = ' ' then
          for i2 := i+1 to Length(ReceiveText) do
            if ReceiveText[i2] = ' ' then
              for i3 := i2+1 to Length(ReceiveText) do
                if ReceiveText[i3] = ' ' then
                begin
                  Result := Copy(ReceiveText, i2+1, i3-i2-1);
                  Exit;
                end;
end;

Function PrivMsg(Target, Msg:String):String;
begin
  Result := 'PRIVMSG ' + Target + ' :' + Msg + #10;
end;

Function GetMessage(ReceiveText:String):String;
var i : Integer;
begin
  Result := '';
  for i := 2 to Length(ReceiveText) do
    if ReceiveText[i] = ':' then
    begin
      Result := Copy(ReceiveText, i+1, Length(ReceiveText)-i);
      Exit;
    end;
end;

Function GetFirstCom(ReceiveText:String):String;
var i, i2 : Integer;
begin
  Result := '';
  for i := 2 to Length(ReceiveText) do
    if ReceiveText[i] = ':' then
      for i2 := i to Length(ReceiveText) do
        if (ReceiveText[i2+1] = ' ') or (i2 = Length(ReceiveText)) then
        begin
          Result := Copy(ReceiveText, i+1, i2-i);
          Exit;
        end;
end;

Function GetSecondCom(ReceiveText:String):String;
var i, i2, i3 : Integer;
begin
  Result := '';
  for i := 2 to Length(ReceiveText) do
    if ReceiveText[i] = ':' then
      for i2 := i to Length(ReceiveText) do
        if ReceiveText[i2] = ' ' then
          for i3 := i2+1 to Length(ReceiveText) do
            if (ReceiveText[i3+1] = ' ') or (i3 = Length(ReceiveText)) then
            begin
              Result := Copy(ReceiveText, i2+1, i3-i2);
              Exit;
            end;
end;

Function ServerCommand(Command:String):String;
begin
  Result := Command + #10;
end;

Function SetMode(Channel,Mode,Target:String):String;
begin
  Result := 'MODE ' + Channel + ' ' + Mode + ' ' + Target + #10;
end;

Function SetTopic(Channel,Topic:String):String;
begin
  Result := 'TOPIC ' + Channel + ' :' + Topic + #10;
end;

end.
