unit MainForm_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, StdCtrls, ExtCtrls, IRC, ScktComp;

type
  Profile = record
    Name : String[50];
    IRCServer : String[50];
    IRCPort : Word;
    BotNick : String[20];
    Channel : String[25];
  end;

  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Programm1: TMenuItem;
    Beenden1: TMenuItem;
    Options1: TMenuItem;
    About1: TMenuItem;
    IRC1: TMenuItem;
    Profil1: TMenuItem;
    StatusBar: TStatusBar;
    Panel1: TPanel;
    OnlineButton: TButton;
    OfflineButton: TButton;
    IdentServer: TServerSocket;
    IRCClient: TClientSocket;
    Commands1: TMenuItem;
    procedure Beenden1Click(Sender: TObject);
    procedure IRC1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Profil1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IdentServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure IRCClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure IRCClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnlineButtonClick(Sender: TObject);
    procedure OfflineButtonClick(Sender: TObject);
    procedure IRCClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Commands1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Procedure SaveProfile;
Procedure TextReceived(index:String);
Procedure CheckMsg(Command:String);

const
  Version = '1.00';

var
  MainForm : TMainForm;
  MainProfile : Profile;

implementation

uses IRCOptionsForm_Unit, AboutForm_Unit, ProfilesForm_Unit,
  CommandsForm_Unit;

{$R *.dfm}

procedure TMainForm.Beenden1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.IRC1Click(Sender: TObject);
begin
  IRCOptionsForm.ShowModal;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.Profil1Click(Sender: TObject);
begin
  ProfilesForm.ShowModal;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  StatusBar.Panels[0].Text := 'Status: Offline';
  StatusBar.Panels[1].Text := 'Profile: [none]';
end;

Procedure SaveProfile;
var ProfilesFile : File of Profile;
    ProfilesIndex : Profile;
    ProfilesPath : String;
begin
  ProfilesPath := GetCurrentDir + '\PROFILES\';
  AssignFile(ProfilesFile, ProfilesPath + 'profiles.dat');
  Reset(ProfilesFile);
  while not EoF(ProfilesFile) do
  begin
    Read(ProfilesFile, ProfilesIndex);
    if AnsiLowerCase(ProfilesIndex.Name) = AnsiLowerCase(MainProfile.Name) then
    begin
      Seek(ProfilesFile, FilePos(ProfilesFile)-1);
      Write(ProfilesFile, MainProfile);
      break;
    end;
  end;
  CloseFile(ProfilesFile);
end;

procedure TMainForm.IdentServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  IdentServer.Socket.Connections[0].SendText(IdentText(IdentServer.Socket.Connections[0].ReceiveText,'Info-B0T','Info-B0T'));
end;

procedure TMainForm.IRCClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  IRCClient.Socket.SendText(LogonText(MainProfile.BotNick, 'Info-B0T', 'Info-B0T (c) 2001 CREEQ'));
end;

procedure TMainForm.IRCClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var index: String;
    i, i2 : Integer;
begin
  index := IRCClient.Socket.ReceiveText;
  for i := 1 to Length(index) do
    if (index[i-1] = #10) or (i = 1) then
      for i2 := i+1 to Length(index) do
        if index[i2] = #10 then
        begin
          TextReceived(Copy(index, i, i2-i-1));
          break;
        end;
end;

Procedure CheckMsg(Command:String);
var CommandsFile : TextFile;
    index : String;
    ProfilesPath : String;
begin
  ProfilesPath := GetCurrentDir + '\PROFILES\';
  if FileExists(ProfilesPath + MainProfile.Name + '.dat') then
  begin
    AssignFile(CommandsFile, ProfilesPath + MainProfile.Name + '.dat');
    Reset(CommandsFile);
    while not EoF(CommandsFile) do
    begin
      ReadLn(CommandsFile, Index);
      if (Length(Index) > 0) and (Index[1] = 'C') then
        if AnsiLowerCase(Copy(index, 2, Length(index)-1)) = AnsiLowerCase(Command) then
        begin
          with MainForm do
          begin
            ReadLn(CommandsFile, Index);
            while (Length(Index) > 0) and (Index[1] = 'M') do
            begin
              if Index = 'M' then Index := 'M ';
              IRCClient.Socket.SendText(PrivMsg(MainProfile.Channel, Copy(Index, 2, Length(Index)-1)));
              ReadLn(CommandsFile, Index);
            end;
          end;
          CloseFile(CommandsFile);
          Exit;
        end;
    end;
    CloseFile(CommandsFile);
  end;
end;

procedure TextReceived(index:String);
var Action_, Msg_ : String;
begin
  Action_ := GetAction(index);
  Msg_ := GetMessage(index);
  with MainForm do
  begin
    if Ping(index) then IRCClient.Socket.SendText(Pong(index));
    if (Action_ = '422') or (Action_ = '376') then
    begin
      IdentServer.Active := FALSE;
      IRCClient.Socket.SendText(JoinChannel(MainProfile.Channel));
      StatusBar.Panels[0].Text := 'Status: Online';
    end;
    if Action_ = 'PRIVMSG' then
    begin
      if Msg_ = '!info' then
      begin
        IRCClient.Socket.SendText(PrivMsg(MainProfile.Channel, '15,1|-------------------------------|'));
        IRCClient.Socket.SendText(PrivMsg(MainProfile.Channel, '15,1|8Info-B0T15                       |'));
        IRCClient.Socket.SendText(PrivMsg(MainProfile.Channel, '15,1|Version ' + Version + '                   |'));
        IRCClient.Socket.SendText(PrivMsg(MainProfile.Channel, '15,1|Written by: 8CREEQ15          |'));
        IRCClient.Socket.SendText(PrivMsg(MainProfile.Channel, '15,1|eMail: 8creeq@web.de15|'));
        IRCClient.Socket.SendText(PrivMsg(MainProfile.Channel, '15,1|Homepage: 8fool.homelinux.org15   |'));
        IRCClient.Socket.SendText(PrivMsg(MainProfile.Channel, '15,1|-------------------------------|'));
      end;
      CheckMsg(Msg_);
    end;
  end;
end;

procedure TMainForm.OnlineButtonClick(Sender: TObject);
begin
  IRCClient.Host := MainProfile.IRCServer;
  IRCClient.Port := MainProfile.IRCPort;
  IdentServer.Active := TRUE;
  IRCClient.Active := TRUE;
  OnlineButton.Enabled := FALSE;
  OfflineButton.Enabled := TRUE;
end;

procedure TMainForm.OfflineButtonClick(Sender: TObject);
begin
  IRCClient.Socket.SendText(QuitIRC('8,1 Info-B0T (c) 2001 CREEQ'));
  IdentServer.Active := FALSE;
  IRCClient.Active := FALSE;
  StatusBar.Panels[0].Text := 'Status: Offline';
end;

procedure TMainForm.IRCClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar.Panels[0].Text := 'Status: Offline';
  OnlineButton.Enabled := TRUE;
  OfflineButton.Enabled := FALSE;
end;

procedure TMainForm.Commands1Click(Sender: TObject);
begin
  CommandsForm.ShowModal;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  AboutForm.VersionLabel.Caption := 'Version ' + Version;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OfflineButton.Click;
end;

end.
